//
// PlatesAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PlatesAPI {
    /**
     Create new plate

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createPlate(body: PlateCreate, completion: @escaping ((_ data: PlateGet?,_ error: Error?) -> Void)) {
        createPlateWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new plate
     - POST /api/v1/plates

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "owner_full_name" : "owner_full_name",
  "number" : "number",
  "car_manufacturer" : "car_manufacturer",
  "car_model" : "car_model",
  "car_image_url" : "http://example.com/aeiou",
  "owner_birth_date" : "2000-01-23",
  "owner_document_number" : "owner_document_number",
  "car_manufacture_date" : "2000-01-23",
  "car_color" : "car_color",
  "id" : 0,
  "car_image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "car_type" : "car_type"
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<PlateGet> 
     */
    open class func createPlateWithRequestBuilder(body: PlateCreate) -> RequestBuilder<PlateGet> {
        let path = "/api/v1/plates"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlateGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete plate with provided ID

     - parameter plateId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deletePlate(plateId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deletePlateWithRequestBuilder(plateId: plateId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete plate with provided ID
     - DELETE /api/v1/plates/{plate_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter plateId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deletePlateWithRequestBuilder(plateId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/plates/{plate_id}"
        let plateIdPreEscape = "\(plateId)"
        let plateIdPostEscape = plateIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plate_id}", with: plateIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get plate with provided ID

     - parameter plateId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlate(plateId: Int, completion: @escaping ((_ data: PlateGet?,_ error: Error?) -> Void)) {
        getPlateWithRequestBuilder(plateId: plateId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get plate with provided ID
     - GET /api/v1/plates/{plate_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "owner_full_name" : "owner_full_name",
  "number" : "number",
  "car_manufacturer" : "car_manufacturer",
  "car_model" : "car_model",
  "car_image_url" : "http://example.com/aeiou",
  "owner_birth_date" : "2000-01-23",
  "owner_document_number" : "owner_document_number",
  "car_manufacture_date" : "2000-01-23",
  "car_color" : "car_color",
  "id" : 0,
  "car_image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "car_type" : "car_type"
}}]
     - parameter plateId: (path)  

     - returns: RequestBuilder<PlateGet> 
     */
    open class func getPlateWithRequestBuilder(plateId: Int) -> RequestBuilder<PlateGet> {
        var path = "/api/v1/plates/{plate_id}"
        let plateIdPreEscape = "\(plateId)"
        let plateIdPostEscape = plateIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plate_id}", with: plateIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlateGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get all plates optionally filtered by plate number

     - parameter number: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlates(number: String? = nil, completion: @escaping ((_ data: PlateGetList?,_ error: Error?) -> Void)) {
        getPlatesWithRequestBuilder(number: number).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get all plates optionally filtered by plate number
     - GET /api/v1/plates

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "plates" : [ {
    "owner_full_name" : "owner_full_name",
    "number" : "number",
    "car_manufacturer" : "car_manufacturer",
    "car_model" : "car_model",
    "car_image_url" : "http://example.com/aeiou",
    "owner_birth_date" : "2000-01-23",
    "owner_document_number" : "owner_document_number",
    "car_manufacture_date" : "2000-01-23",
    "car_color" : "car_color",
    "id" : 0,
    "car_image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "car_type" : "car_type"
  }, {
    "owner_full_name" : "owner_full_name",
    "number" : "number",
    "car_manufacturer" : "car_manufacturer",
    "car_model" : "car_model",
    "car_image_url" : "http://example.com/aeiou",
    "owner_birth_date" : "2000-01-23",
    "owner_document_number" : "owner_document_number",
    "car_manufacture_date" : "2000-01-23",
    "car_color" : "car_color",
    "id" : 0,
    "car_image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "car_type" : "car_type"
  } ]
}}]
     - parameter number: (query)  (optional)

     - returns: RequestBuilder<PlateGetList> 
     */
    open class func getPlatesWithRequestBuilder(number: String? = nil) -> RequestBuilder<PlateGetList> {
        let path = "/api/v1/plates"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "number": number
        ])


        let requestBuilder: RequestBuilder<PlateGetList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Update plate with provided ID

     - parameter body: (body)  
     - parameter plateId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updatePlate(body: PlateUpdate, plateId: Int, completion: @escaping ((_ data: PlateGet?,_ error: Error?) -> Void)) {
        updatePlateWithRequestBuilder(body: body, plateId: plateId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update plate with provided ID
     - PUT /api/v1/plates/{plate_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "owner_full_name" : "owner_full_name",
  "number" : "number",
  "car_manufacturer" : "car_manufacturer",
  "car_model" : "car_model",
  "car_image_url" : "http://example.com/aeiou",
  "owner_birth_date" : "2000-01-23",
  "owner_document_number" : "owner_document_number",
  "car_manufacture_date" : "2000-01-23",
  "car_color" : "car_color",
  "id" : 0,
  "car_image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "car_type" : "car_type"
}}]
     - parameter body: (body)  
     - parameter plateId: (path)  

     - returns: RequestBuilder<PlateGet> 
     */
    open class func updatePlateWithRequestBuilder(body: PlateUpdate, plateId: Int) -> RequestBuilder<PlateGet> {
        var path = "/api/v1/plates/{plate_id}"
        let plateIdPreEscape = "\(plateId)"
        let plateIdPostEscape = plateIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{plate_id}", with: plateIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlateGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
